%define anolis_release 2
%global base_version 2.21
Name:           perl-threads
Epoch:          1
Version:        2.27
Release:        %{anolis_release}%{?dist}
Summary:        Perl interpreter-based threads
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/threads
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/threads-%{base_version}.tar.gz
Patch0:         threads-2.21-Upgrade-to-2.22.patch
Patch1:         threads-2.21-Upgrade-to-2.25.patch
Patch2:         threads-2.25-Upgrade-to-2.26.patch
Patch3:         threads-2.26-Upgrade-to-2.27.patch
BuildRequires:  gcc make
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Config)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(Carp)
BuildRequires:  perl(overload)
BuildRequires:  perl(XSLoader)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(blib)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(IO::File)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(Hash::Util)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(ExtUtils::testlib)
Requires:       perl(Carp)
BuildRequires:  perl(Thread::Queue)
BuildRequires:  perl(Thread::Semaphore)
BuildRequires:  perl(threads::shared)

%{?perl_default_filter}

%description
Perl-threads is a module in Perl that provides support for multiple threads of
control in a Perl program. Threads are lightweight processes that can run
concurrently within a single program. They provide a way to perform multiple
tasks simultaneously, which can greatly enhance the performance and
responsiveness of a program.

The Perl-threads module provides a simple and easy-to-use interface for
creating and managing threads in a Perl program. It provides functions for
creating new threads, starting and stopping threads, and for communicating
between threads using shared data structures.

One of the key features of Perl-threads is its ability to perform true parallel
processing. This means that multiple threads can execute code simultaneously on
different processors or cores, allowing for maximum use of available system
resources.

Another important feature of Perl-threads is its support for thread
synchronization. This allows multiple threads to coordinate their actions and
avoid conflicts when accessing shared resources, such as variables or files.

Perl-threads also provides a number of other advanced features, such as
thread-local variables, which allow each thread to have its own private data,
and thread pools, which can be used to manage a group of threads for a specific
task.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n threads-%{base_version}
chmod -x examples/*

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -delete
%{_fixperms} $RPM_BUILD_ROOT/*

%check
unset GIT_DIR PERL_BUILD_PACKAGING PERL_CORE PERL_RUNPERL_DEBUG \
    PERL5_ITHREADS_STACK_SIZE RUN_MAINTAINER_TESTS
make test

%files
%{_mandir}/man3/*
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/threads*

%files doc
%doc Changes examples README

%changelog
* Thu Apr 13 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 1:2.27-2
- Optimize the spec

* Thu Feb 09 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:2.27-1
- remove versioned MODULE_COMPAT_ requires
- update to version 2.27

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:2.21-2
- rebuild with perl 5.36.0

* Tue Mar 08 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:2.21-1
- Init from upstream version 2.21

